=== debian/changelog ===
libreoffice (1:4.0.3-2~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Rene Engelhard <rene@debian.org>  Sat, 11 May 2013 11:11:45 +0000

libreoffice (1:4.0.3-2) unstable; urgency=low

  * debian/control.in:
    - add Breaks: libjaxe-java (<= 3.5-2) for saxon9.jar disappearing from
      -java-common
    - remove -core Depends: for -style and add Enhances: libreoffice-core 
      for them. Apps should depend on their data files but data files not on
      the apps
  * debian/rules:
    - build with libboost1.53-dev to work around mdds-using sc unit tests
      failing to build with sids new gcc-4.7
    - move libxmlreader.so (although not versioned...) and libreg.so.3 (although
      private...) and it's dependency libstore.so.3 into uno-libs3 as
      libuno_cppuhelpergcc3.so.3 now links to it (breaks ure->uno-libs3->ure
      dependency loop)

   (hopefully breaking those two dependency loops closes: #705158, thanks
    David Kalnischkies - see also #707578)

 -- Rene Engelhard <rene@debian.org>  Sat, 11 May 2013 01:20:03 +0200

libreoffice (1:4.0.3-1) unstable; urgency=low

  * LibreOffice 4.0.3 final (identical to rc3)

  * upload to unstable

 -- Rene Engelhard <rene@debian.org>  Sun, 05 May 2013 17:55:51 +0200

libreoffice (1:4.0.3~rc3-1) experimental; urgency=low

  * new upstream release candidate

  * debian/control.in:
    - break zotero-libreoffice-integration (<= 3.0.11.1-26-g08fb709-1), see
      #705998)
    - add (commented out for now - as long we are python3.3-uno anyways) the
      missing Provides: ${python3:Provides}
  * debian/uno-libs3.symbols: update and cleanup - use (symver) instead
    of *@...
  * debian/copyright: mention gbuild (and its makefiles) are MPL-2.0

 -- Rene Engelhard <rene@debian.org>  Thu, 02 May 2013 21:06:26 +0200

libreoffice (1:4.0.3~rc1-3) experimental; urgency=low

  * The "the third time is a charm" release
  * fix check rule again: move - where it actually works; also ignore
    test failures on s390 and powerpc and simplify logic

 -- Rene Engelhard <rene@debian.org>  Sun, 21 Apr 2013 17:14:49 +0200

libreoffice (1:4.0.3~rc1-2) experimental; urgency=low

  * brown paper bag release
  * fix make -k check || make check rule

 -- Rene Engelhard <rene@debian.org>  Fri, 19 Apr 2013 17:47:59 +0200

libreoffice (1:4.0.3~rc1-1) experimental; urgency=low

  * new upstream release candidate

  * debian/control.librelogo.in:
    - actually use ${pyuno-depends}... 
  * debian/rules:
    - enable liblangtag on arm*, too now that it's available there
    - Use internal clucene until clucene 2.x is in unstable. Remove
      arm* hack for internal clucene as it seems to work in the
      meanwhile
    - explicitly set JDK=openjdk again until default-jdk (>= 1:1.7-48)
      is in unstable (needed for ia64 defaulting to java7)
    - run make -k check || make check (try to work around spurious failures) and
      ignore test suite failures (on the second run) on armhf, ia64, sparc,
      mips(el)

 -- Rene Engelhard <rene@debian.org>  Wed, 10 Apr 2013 23:15:27 +0200

libreoffice (1:4.0.2~rc2-2) experimental; urgency=low

  * debian/patches/boost-1.53.diff: backport buildfixes for boost 1.53
    from master

  * debian/rules:
    - build-depend on libboost-dev 1.53 when building with gcc 4.8,
      see 701310/695826 (closes: #701310)
    - always build -dbg package if we build -subsequentcheckbase, as the
      test depends on -dbg
    - build against "new" libhsqldb1.8.0-java
    - we need to build-depend on python3 even when building python3.3-uno
      as it contains dh_python3...
  * debian/control.in:
    - add Breaks: on libreoffice-writer2latex/libreoffice-writer2xhtml
      (<< 1.0.2-9) due to LO 4.0 API change

 -- Rene Engelhard <rene@debian.org>  Tue, 02 Apr 2013 00:13:23 +0200
